Index: typo3/alt_doc.php
===================================================================
--- typo3/alt_doc.php	(revision 2834)
+++ typo3/alt_doc.php	(working copy)
@@ -432,8 +432,7 @@
 			// If empty string it's just a variable, that'll be saved.
 			// Values NOT in this array will not be saved in the settings-array for the module.
 		$this->MOD_MENU = array(
-			'showPalettes' => '',
-			'showDescriptions' => ''
+			'showPalettes' => ''
 		);
 
 			// Setting virtual document name
@@ -538,7 +537,7 @@
 			$this->tceforms->clipObj->initializeClipboard();	// Initialize - reads the clipboard content from the user session
 
 				// Setting external variables:
-			if ($BE_USER->uc['edit_showFieldHelp']!='text' && $this->MOD_SETTINGS['showDescriptions'])	$this->tceforms->edit_showFieldHelp='text';
+			$this->tceforms->edit_showFieldHelp = $BE_USER->uc['edit_showFieldHelp'];
 
 			if ($this->editRegularContentFromId)	{
 				$this->editRegularContentFromId();
@@ -1035,21 +1034,12 @@
 	 * @return	string		HTML for function menus.
 	 */
 	function functionMenus()	{
-		global $BE_USER,$LANG;
+		global $LANG;
 
-		$funcMenus = '';
-
 			// Show palettes:
-		$funcMenus.= '<br /><br />'.t3lib_BEfunc::getFuncCheck('','SET[showPalettes]',$this->MOD_SETTINGS['showPalettes'],'alt_doc.php',t3lib_div::implodeArrayForUrl('',array_merge($this->R_URL_getvars,array('SET'=>''))),'id="checkShowPalettes"').'<label for="checkShowPalettes">'.$LANG->sL('LLL:EXT:lang/locallang_core.php:labels.showPalettes',1).'</label>';
-
-			// Show descriptions/help texts:
-		if ($BE_USER->uc['edit_showFieldHelp']!='text') {
-			$funcMenus.= '<br />'.t3lib_BEfunc::getFuncCheck('','SET[showDescriptions]',$this->MOD_SETTINGS['showDescriptions'],'alt_doc.php',t3lib_div::implodeArrayForUrl('',array_merge($this->R_URL_getvars,array('SET'=>''))),'id="checkShowDescriptions"').'<label for="checkShowDescriptions">'.$LANG->sL('LLL:EXT:lang/locallang_core.php:labels.showDescriptions',1).'</label>';
-		}
-
 		return '
 				<!-- Function menus (checkboxes for selecting options): -->
-				'.$funcMenus;
+				<br /><br />'.t3lib_BEfunc::getFuncCheck('','SET[showPalettes]',$this->MOD_SETTINGS['showPalettes'],'alt_doc.php',t3lib_div::implodeArrayForUrl('',array_merge($this->R_URL_getvars,array('SET'=>''))),'id="checkShowPalettes"').'<label for="checkShowPalettes">'.$LANG->sL('LLL:EXT:lang/locallang_core.php:labels.showPalettes',1).'</label>';
 	}
 
 
Index: typo3/sysext/setup/mod/index.php
===================================================================
--- typo3/sysext/setup/mod/index.php	(revision 2834)
+++ typo3/sysext/setup/mod/index.php	(working copy)
@@ -372,9 +372,16 @@
 		$code[5][2] = '<input type="checkbox" name="data[thumbnailsByDefault]"'.($BE_USER->uc['thumbnailsByDefault']?' checked="checked"':'').' />';
 		$code[6][1] = $this->setLabel('helpText');
 		$code[6][2] = '<input type="checkbox" name="data[helpText]"'.($BE_USER->uc['helpText']?' checked="checked"':'').' />';
-		$code[7][1] = $this->setLabel('maxTitleLen','titleLen');
-		$code[7][2] = '<input type="text" name="data[titleLen]" value="'.$BE_USER->uc['titleLen'].'"'.$GLOBALS['TBE_TEMPLATE']->formWidth(5).' maxlength="5" />';
+		$code[7][1] = $this->setLabel('edit_showFieldHelp');
+		$code[7][2] = '<select name="data[edit_showFieldHelp]">
+			<option value=""></option>
+			<option value="icon"'.($BE_USER->uc['edit_showFieldHelp']=='icon'?' selected="selected"':'').'>'.$this->setLabel('edit_showFieldHelp_icon').'</option>
+			<option value="text"'.($BE_USER->uc['edit_showFieldHelp']=='text'?' selected="selected"':'').'>'.$this->setLabel('edit_showFieldHelp_message').'</option>
+		</select>';
 
+		$code[8][1] = $this->setLabel('maxTitleLen','titleLen');
+		$code[8][2] = '<input type="text" name="data[titleLen]" value="'.$BE_USER->uc['titleLen'].'"'.$GLOBALS['TBE_TEMPLATE']->formWidth(5).' maxlength="5" />';
+
 		$this->content.=$this->doc->section($LANG->getLL('opening').':',$this->doc->table($code),0,1);
 
 
@@ -399,16 +406,9 @@
 		$code[4][1] = $this->setLabel('edit_docModuleUpload');
 		$code[4][2] = '<input type="checkbox" name="data[edit_docModuleUpload]"'.($BE_USER->uc['edit_docModuleUpload']?' checked="checked"':'').' />';
 
-		$code[6][1] = $this->setLabel('edit_showFieldHelp');
-		$code[6][2] = '<select name="data[edit_showFieldHelp]">
-			<option value=""></option>
-			<option value="icon"'.($BE_USER->uc['edit_showFieldHelp']=='icon'?' selected="selected"':'').'>'.$this->setLabel('edit_showFieldHelp_icon').'</option>
-			<option value="text"'.($BE_USER->uc['edit_showFieldHelp']=='text'?' selected="selected"':'').'>'.$this->setLabel('edit_showFieldHelp_message').'</option>
-		</select>';
+		$code[6][1] = $this->setLabel('disableCMlayers');
+		$code[6][2] = '<input type="checkbox" name="data[disableCMlayers]"'.($BE_USER->uc['disableCMlayers']?' checked="checked"':'').' />';
 
-		$code[7][1] = $this->setLabel('disableCMlayers');
-		$code[7][2] = '<input type="checkbox" name="data[disableCMlayers]"'.($BE_USER->uc['disableCMlayers']?' checked="checked"':'').' />';
-
 		$this->content.=$this->doc->section($LANG->getLL('edit_functions').":",$this->doc->table($code),0,1);
 
 
@@ -575,4 +575,4 @@
 $SOBE->init();
 $SOBE->main();
 $SOBE->printContent();
-?>
\ No newline at end of file
+?>