Index: t3lib/config_default.php
===================================================================
--- t3lib/config_default.php	(revision 2744)
+++ t3lib/config_default.php	(working copy)
@@ -23,7 +23,9 @@
 		'thumbnails_png' => 0,					// Bits. Bit0: If set, thumbnails from non-jpegs will be 'png', otherwise 'gif' (0=gif/1=png). Bit1: Even JPG's will be converted to png or gif (2=gif/3=png)
 		'noIconProc' => 1,						// Boolean. If true, icons are never processed with overlays for hidden, starttime, endtime etc. They must be available pre-processed. If this is disabled, do so only if you have full image processing capabilities on the server for TYPO3.
 		'gif_compress' => 1,					// Boolean. Enables the use of the t3lib_div::gif_compress() workaround function for compressing giffiles made with GD or IM, which probably use only RLE or no compression at all.
-		'imagefile_ext' => 'gif,jpg,jpeg,tif,bmp,pcx,tga,png,pdf,ai',	// Commalist of file extensions perceived as images by TYPO3. List should be set to 'gif,png,jpeg,jpg' if IM is not available. Lowercase and no spaces between!
+		'imagefile_ext' => 'gif,jpg,jpeg,tif,bmp,pcx,tga,png,pdf,ai',	// Commalist of file extensions perceived as images by TYPO3. List should be set to 'gif,png,jpeg,jpg' if IM is not available. Lowercase and no spaces between! When you add "swf,
+		'multimediafile_ext' => 'swf,swa,dcr,avi,mov,mpg,asf,wmv',	// Commalist of file extensions perceived as multimedia types by TYPO3.
+		
 
 		'gdlib' => 1,							// Boolean. Enables the use of GD.
 		'gdlib_png' => 0,						// Boolean. Enables the use of GD, with PNG only. This means that all items normally generated as gif-files will be png-files instead!
@@ -166,6 +168,7 @@
 		'notificationPrefix' => '[TYPO3 Note]',
 		'accessListRenderMode' => 'singlebox',	// Can be "singlebox", "checkbox" or blank. Refers to the "renderMode" for the selector boxes in be-groups configuration.
 		'explicitADmode' => 'explicitDeny',	// Sets the general allow/deny mode for selector box values. Value can be either "explicitAllow" or "explicitDeny", nothing else!
+		'multimediaTextpic' => 1,	// Boolean. When set multimedia files are allowed for "Text w. Image" or "Image" content elements.
 		'XCLASS' => Array(),					// See 'Inside TYPO3' document for more information.
 		'niceFlexFormXMLtags' => TRUE,			// If set, the flexform XML will be stored with meaningful tags which can be validated with DTD/schema. If you rely on custom reading of the XML from pre-4.0 versions you should set this to false if you don't like to change your reader code (internally it is insignificant since t3lib_div::xml2array() doesn't care for the tags if the index-attribute value is set)
 		'flexFormXMLincludeDiffBase' => TRUE,	// If set, an additional tag with index "vXX.vDEFbase" is created for translations in flexforms holding the value of the default language when translation was changed. Used to show diff of value. This setting will change whether the system thinks flexform XML looks clean. For example when FALSE XX.vDEFbase fields will be removed in cleaning while accepted if TRUE (of course)
Index: typo3/sysext/cms/tbl_tt_content.php
===================================================================
--- typo3/sysext/cms/tbl_tt_content.php	(revision 2744)
+++ typo3/sysext/cms/tbl_tt_content.php	(working copy)
@@ -396,7 +396,7 @@
 			'config' => Array (
 				'type' => 'group',
 				'internal_type' => 'file',
-				'allowed' => $GLOBALS['TYPO3_CONF_VARS']['GFX']['imagefile_ext'],
+				'allowed' => $GLOBALS['TYPO3_CONF_VARS']['GFX']['imagefile_ext'].($GLOBALS['TYPO3_CONF_VARS']['BE']['multimediaTextpic']?','.$GLOBALS['TYPO3_CONF_VARS']['GFX']['multimediafile_ext']:''),
 				'max_size' => $GLOBALS['TYPO3_CONF_VARS']['BE']['maxFileSize'],
 				'uploadfolder' => 'uploads/pics',
 				'show_thumbs' => '1',
@@ -809,7 +809,7 @@
 			'config' => Array (
 				'type' => 'group',
 				'internal_type' => 'file',
-				'allowed' => 'txt,html,htm,class,swf,swa,dcr,wav,avi,au,mov,asf,mpg,wmv,mp3',
+				'allowed' => 'txt,html,htm,class,wav,au,mp3,'.$GLOBALS['TYPO3_CONF_VARS']['GFX']['multimediafile_ext'],
 				'max_size' => $GLOBALS['TYPO3_CONF_VARS']['BE']['maxFileSize'],
 				'uploadfolder' => 'uploads/media',
 				'size' => '2',
Index: typo3/sysext/cms/tslib/class.tslib_content.php
===================================================================
--- typo3/sysext/cms/tslib/class.tslib_content.php	(revision 2744)
+++ typo3/sysext/cms/tslib/class.tslib_content.php	(working copy)
@@ -2470,6 +2470,7 @@
 			} else {
 					// default params...
 				$parArray=array();
+				$parVal=array();
 					// src is added
 				$parArray['src']='src="'.$GLOBALS['TSFE']->absRefPrefix.$incFile.'"';
 				if (t3lib_div::inList('au,wav,mp3',$fileinfo['fileext']))	{
@@ -2493,6 +2494,7 @@
 					$parameter = strtolower(trim($parts[0]));
 					$value = trim($parts[1]);
 					if ((string)$value!='')	{
+						$parVal[$parameter] = $value;
 						$parArray[$parameter] = $parameter.'="'.htmlspecialchars($value).'"';
 					} else {
 						unset($parArray[$parameter]);
@@ -2506,6 +2508,8 @@
 				} else {
 					$content='<embed '.implode(' ',$parArray).'></embed>';
 				}
+				$GLOBALS['TSFE']->lastImageInfo = array(intval($parVal['width'], intval($parVal['height'], strtolower($fileinfo['fileext']), $incFile)));
+
 			}
 		}
 
Index: typo3/sysext/css_styled_content/static/setup.txt
===================================================================
--- typo3/sysext/css_styled_content/static/setup.txt	(revision 2744)
+++ typo3/sysext/css_styled_content/static/setup.txt	(working copy)
@@ -1273,6 +1273,28 @@
 			bodyTag = <body style="margin:0; background:#fff;">
 			JSwindow.expand =
 		}
+		stdWrap {
+			wrap = |
+			override {
+				if	{
+					isInList	{
+						current = 1
+						substring = -3,3
+						case = upper
+					}
+					value = SWF,SWA,DCR,AVI,MOV,MPG,ASF,WMV
+				}
+				postCObject = MULTIMEDIA
+				postCObject {
+				file {
+					current = 1
+				}
+				params.dataWrap (
+					width={field:imagewidth}
+					height={field:imageheight}
+				)
+			}	
+		}
 	}
 
 	caption.1.wrapAlign >